您的位置:首页 > 其它

HDU 4323 编辑距离DP

2013-10-11 23:04 393 查看

Magic Number

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/65536 K (Java/Others)

Total Submission(s): 1333 Accepted Submission(s): 562



Problem Description
There are many magic numbers whose lengths are less than 10. Given some queries, each contains a single number, if the Levenshtein distance (see below) between the number in the query and a magic number is no more than a threshold,
we call the magic number is the lucky number for that query. Could you find out how many luck numbers are there for each query?

Levenshtein distance (from Wikipedia http://en.wikipedia.org/wiki/Levenshtein_distance):
In information theory and computer science, the Levenshtein distance is a string metric for measuring the amount of difference between two sequences. The term edit distance is often used to refer specifically to Levenshtein distance.

The Levenshtein distance between two strings is defined as the minimum number of edits needed to transform one string into the other, with the allowable edit operations being insertion, deletion, or substitution of a single character. It is named after Vladimir
Levenshtein, who considered this distance in 1965.

For example, the Levenshtein distance between "kitten" and "sitting" is 3, since the following three edits change one into the other, and there is no way to do it with fewer than three edits:

1.kitten → sitten (substitution of 's' for 'k')

2.sitten → sittin (substitution of 'i' for 'e')

3.sittin → sitting (insertion of 'g' at the end).



Input
There are several test cases. The first line contains a single number T shows that there are T cases. For each test case, there are 2 numbers in the first line: n (n <= 1500) m (m <= 1000) where n is the number of magic numbers and
m is the number of queries.

In the next n lines, each line has a magic number. You can assume that each magic number is distinctive.

In the next m lines, each line has a query and a threshold. The length of each query is no more than 10 and the threshold is no more than 3.



Output
For each test case, the first line is "Case #id:", where id is the case number. Then output m lines. For each line, there is a number shows the answer of the corresponding query.


Sample Input
1
5 2
656
67
9313
1178
38
87 1
9509 1




Sample Output
Case #1:
1
0


思路:这题一看肯定是编辑距离了,以前学长教过我们方法和算法,但是那时没有学DP,所以学长把把复杂化了,刚才研究了好久,把它改成了DP的,比较简便……不过刚才小地方弄了好久,弄了2个小时了才得过,差点晕死……

#include<iostream>
#include<algorithm>
#include<cstring>
#include<cmath>
#include<cstdio>
using namespace std;
const int M=1510;
int b[M][M];
char p[M][11],q[M][11];
int DP(char *x,char *y)
{
    int i,j,m,n,t;
	m=strlen(x);
	n=strlen(y);
    for(i=0;i<=(m>n?m:n);i++)
    {
        b[i][0]=i;
        b[0][i]=i;
    }
    for(i=1;i<=m;i++)
        for(j=1;j<=n;j++)
            if(x[i-1]==y[j-1]) b[i][j]=b[i-1][j-1]; //如果当前两个字母相等的话,编辑为0,这时就等于前一组的值了
            else
            {
                b[i][j]=min(b[i-1][j]+1,b[i][j-1]+1);
                b[i][j]=min(b[i][j],b[i-1][j-1]+1);
            }
    return b[m]
;
}
int main()
{
	int t,k=1;
	scanf("%d",&t);
	while(t--)
	{
		int n,m,i,j,th[1505],l1,l2,sum;
		scanf("%d%d",&n,&m);
		for(i=0;i<n;i++)
			scanf("%s",p[i]);
		for(i=0;i<m;i++)
		    scanf("%s%d",q[i],&th[i]);
        printf("Case #%d:\n",k++);
		for(i=0;i<m;i++)
		{
		    sum=0;
		    l1=strlen(q[i]);
			for(j=0;j<n;j++)
			{
			    l2=strlen(p[j]);
			    if(abs(l1-l2)>th[i]) continue;
			    else if(DP(p[j],q[i])<=th[i]) sum++;
			}
			printf("%d\n",sum);
		}
	}
	return 0;
}


下面是学长教的DP函数中不同的地方,虽然也是动态规划,但是学长应该是把它解释了给我们的,所以看起来有点复杂……
int DP(char *x,char *y)
{
    int i,j,m,n,t;
	m=strlen(x);
	n=strlen(y);
	for(i=0;i<m+1;i++)
        b[i][0]=i;
    for(j=0;j<n+1;j++)
        b[0][j]=j;
    for(i=1; i<m+1; i++)
        for(j=1; j<n+1; j++)
        {
            t=0;
            int min=1010;
            int c[3]={0};
            if(x[i-1]==y[j-1]) t=0;
            else t=1;
            c[0]=b[i-1][j]+1;
            c[1]=b[i][j-1]+1;
            c[2]=b[i-1][j-1]+t;
            for(int k=0; k<3; k++)
                if(min>c[k])min=c[k];
            b[i][j]=min;
        }
    return b[m]
;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: